/*******************************************************************************************************
 *        Hochschule Hamm-Lippstadt                                                                    *
 *******************************************************************************************************
 * Modul           : E01_MotorenTest.ino                             
 *                                                               
 * Datum           : 23. Januar 2021                             
 *                                                               
 * Funktion        : Demo zum Test der Motoren des AlphaBot      
 *                                                                                                                           
 * Hardware        : UNO PLUS + Multisensor Shield  
 * Implementation  : Arduino IDE 2.0.0-beta.4                    
 *                                                               
 * Include         : AlphaBot.cpp                                
 *                   AlphaBot.h                                  
 *                                                               
 * Author          : Prof. Schneider                             
 *                                                               
 * Bemerkung       : basierend auf Waveshare AlphaBot Car Run Test             
 *                   www.waveshare.com/wiki/AlphaBot             
 *                                                               
 * Letzte Änderung : 26. Januar 2021                             
 *                                                               
 ********************************************************************************************************/

/********************************************************************************************************/
/* Vorbereitung: Jumper A1 gesetzt (A0->IN1)                                                            */
/*               PWR SWITCH: ON  (Akkus versorgen Motoren                                               */
/*               Poti: 100% (+), da der Poti ebenfalls an A0 hängt                                      */
/********************************************************************************************************/

#include "AlphaBot.h"

AlphaBot hAlphaBot = AlphaBot(); /* Instanz des Elphabot wird erzeugt. */

/* Konstanten definieren */
#define GESCHWINDIGKEIT 80 // Geschw. wählbar: 0 - 255; Min: 80

void setup()
{
  hAlphaBot.SetSpeed(GESCHWINDIGKEIT);       // Geschw. setzen: 0 - 255
}

void loop()
{ 
  /* Es folgen verschiedene Testmodule. Kommentieren Sie alles bis auf das gewünschte aus. */
  
  delay(1000);
  hAlphaBot.Forward(1000);     // AlphaBot fährt für 1s mit beiden Motoren vorwärts
  hAlphaBot.Brake();
  
//  delay(1000);
//  hAlphaBot.Backward(1000);  // AlphaBot fährt für 1s mit beiden Motoren rückwärts
//  hAlphaBot.Brake();
//
//  delay(1000);
//  hAlphaBot.Left(1000);      // AlphaBot dreht sich für 1s nach links
//  hAlphaBot.Brake();
//
//  delay(1000);
//  hAlphaBot.Right(1000);     // AlphaBot dreht sich für 1s nach rechts
//  hAlphaBot.Brake();

//  delay(1000);
//  hAlphaBot.LeftCircle(1000);  // AlphaBot fährt für 1s einen Linkskreis
//  hAlphaBot.Brake();
//
//  delay(1000);
//  hAlphaBot.RightCircle(1000);  // AlphaBot fährt für 1s einen Rechtskreis
//  hAlphaBot.Brake();
//  
//  delay(1000);  
//  hAlphaBot.MotorRun(250,250);  // AlphaBot fährt für 1s vorwärts; Leistung linker Motor: 250, Leistung rechter Motor: 250
//  delay(1000);
//  hAlphaBot.Brake();
//
//  delay(1000);  
//  hAlphaBot.MotorRun(-250,-250);  // AlphaBot fährt für 1s rückwärts; Leistung linker Motor: -250, Leistung rechter Motor: -250
//  delay(1000);
//  hAlphaBot.Brake();
//  
//  delay(1000);  
//  hAlphaBot.MotorRun(0,250);       // AlphaBot fährt für 1s einen Linkskreis; Leistung linker Motor: 0, Leistung rechter Motor: 250
//  delay(1000);
//  hAlphaBot.Brake();
//
//  delay(1000);  
//  hAlphaBot.MotorRun(250,0);       // AlphaBot fährt für 1s einen Rechtskreis; Leistung linker Motor: 250, Leistung rechter Motor: 0
//  delay(1000);
//  hAlphaBot.Brake();
}
