/*********************************************************************************************************
*        Hochschule Hamm-Lippstadt                                                                       *
**********************************************************************************************************
* Modul            : E13_Photo_Interrupter_Sensor.ino                                                    *
*                                                                                                        *
* Datum            : 29. Juni 2021                                                                       *
*                                                                                                        *
* Funktion         : Auslesen einer Encoderlichtschranke.                                                *
*                                                                                                        *                  
* Implementation   : Arduino IDE 1.8.16                                                                  *                                                                                                        *                                                                         *
*                                                                                                        *
* Autoren          : Prof. Dr. Ulrich Schneider                                                          *                                                                                                      *                                                     *
*                                                                                                        *
* Bemerkung        : Beispielcode basierend auf https://www.waveshare.com/wiki/AlphaBot                  *                                                                                                   
*                                                                                                        *
* Letzte Änderung  : 10. Oktober 2021                                                                    *
*                                                                                                        *                                                  
*********************************************************************************************************/

const int PORT_CNTL = 2;    // Die linke Lichtschranke (CNTL) liegt an Arduino D2 (Jumper B1)
                            // https://www.arduino.cc/reference/de/language/variables/variable-scope-qualifiers/const/

void setup()                // Einmalige Systeminitialisierung
{
  pinMode(PORT_CNTL,INPUT); // Pin als Eingang spezifizieren https://www.arduino.cc/reference/de/language/functions/digital-io/pinmode/
  Serial.begin(9600);       // Serieller Monitor mit 9600 Baud https://www.arduino.cc/reference/de/language/functions/communication/serial/begin/
}
void loop() // Main Schleife
{
  if(digitalRead(PORT_CNTL)==LOW)       // Zustand der Digitalpins lesen und auswerten
  {
    Serial.println("         AN"); // Serielle Textausgabe mit Line Feed https://www.arduino.cc/reference/en/language/functions/communication/serial/println/
  }
  else
  {
    Serial.println("AUS");
  }
  delay(500);                     // Zeitverzögerung in ms
}
