/*******************************************************************************************************
 *        Hochschule Hamm-Lippstadt                                                                    *
 *******************************************************************************************************
 * Modul           : E18b_spieleTon.ino                             
 *                                                               
 * Datum           : 27. März 2021                             
 *                                                               
 * Funktion        : Demo zur Ausgabe eines Ton auf dem Summer des Multisensor-Shields  
 *                                                                                                                           
 * Hardware        : UNO PLUS + Multisensor Shield  
 * Implementation  : Arduino IDE 2.0.0-beta.4                    
 *                                                                                             
 *                                                               
 * Author          : Prof. Schneider                             
 *                                                               
 * Bemerkung       : basierend auf Waveshare AlphaBot Beep.ino           
 *                   www.waveshare.com/wiki/AlphaBot   
 *                   https://www.waveshare.com/wiki/Accessory_Shield          
 *                                                               
 * Letzte Änderung : 27. März 2021                             
 *                                                               
 ********************************************************************************************************/
/********************************************************************************************************/
/* Vorbereitung: Jumper D1 nicht gesetzt, da Ultraschalltrigger (TRIG) auf selbem PIN D11               */
/********************************************************************************************************/

/* Konstanten deklarieren */
#define TON_PIN 11 // PIN AR D11

/* Variablen deklarieren */
unsigned int Frequenz_u16  = 50;    // in Hz
unsigned long TonDauer_u32 = 500;   // in ms

void setup()
{ 
  Serial.begin(9600);   // Serielle Übertragung mit 9600 Bit/s starten
  Serial.println("SETUP");
  pinMode(TON_PIN,OUTPUT); // Konfiguriert den spezifizierten Pin als Input oder Output.

  tone(TON_PIN,330);     // 330 Hz 
  delay(TonDauer_u32);   // für 500 ms
  noTone(TON_PIN);       // Ton aus
  delay(20);
  tone(TON_PIN,700,TonDauer_u32);
  delay(2000);
  Serial.println("starte LOOP");
}
void loop()
{

  if (Frequenz_u16 < 1000) // Schleife über die Frequenzen 50Hz - 1kHz
  {
    Serial.print("Frequenz: ");
    Serial.print(Frequenz_u16);
    Serial.println(" Hz");
    tone(TON_PIN, Frequenz_u16);
    delay(TonDauer_u32);
    Frequenz_u16 = Frequenz_u16 + 50;
  }
  noTone(TON_PIN); // Ton aus
}
