/*********************************************************************************************************
*
* File                : ds3231.ino
* Hardware Environment: UNO PLUS + Accessory Shield
* Build Environment   : Arduino
* Version             : V1.0.6
* By                  : WaveShare
*
*                                  (c) Copyright 2005-2014, WaveShare
*                                       http://www.waveshare.com
*                                       http://www.waveshare.net   
*                                          All Rights Reserved
*
*********************************************************************************************************/
#include <Wire.h>
#include "ds3231.h"

#define BUFF_MAX 128
#define CMD_BUFF 20

uint8_t time[8];
unsigned long prev, interval = 1000;
struct ts t;

char cmd_buff[CMD_BUFF];
unsigned char count = 0, time_tick;
unsigned char cmd_flag = 0;
unsigned char u8_temp, i;
unsigned short u16_temp;

void setup()
{
    Serial.begin(4800);
    Wire.begin();
    DS3231_init(DS3231_INTCN);        //interrupt enable
    Serial.println("test_1");
}

void loop()
{
    char in;
    char buff[BUFF_MAX];
    unsigned long now = millis();
    Serial.println("test_2");
    // Serial.println(buff);
    // show time once in a while
    if ((now - prev) > interval) 
    {
        DS3231_get(&t);
        Serial.println("test_3");
        snprintf(buff, BUFF_MAX, "%d.%02d.%02d %02d:%02d:%02d", t.year,
             t.mon, t.mday, t.hour, t.min, t.sec);
             
        Serial.println(buff);
        prev = now;
        
        time_tick++;
    }
    
    /*
    error process
    */
    Serial.println("test_4");
    if((time_tick >= 2) && (cmd_flag == 1))
    {
      cmd_flag = 0;
      count = 0;
    }
        
    /*
    if conf time and date
    */
   Serial.println("test_5");
    if(Serial.available())
    {
      if(cmd_flag == 0)
      {
      Serial.println("test_6");
        in = Serial.read();
        if(in == '0')
        {
          cmd_flag = 1;
          time_tick = 0;
        }
      }
      else
      {
        cmd_buff[count++] = Serial.read();
        if(count >= 14)                                    //decode and set time 
        {
       Serial.println("test_7");
          cmd_flag = 0;
          count = 0;
          
          for(i = 0; i < 14; i++)
          {
            cmd_buff[i] -= '0';
          }
          /*
          year
          */
         Serial.println("test_8");
          u16_temp = 0;
          u16_temp += cmd_buff[0] * 1000;
          u16_temp += cmd_buff[1] * 100;
          u16_temp += cmd_buff[2] * 10;
          u16_temp += cmd_buff[3];
          t.year = u16_temp;
          
          /*
          month
          */
          u8_temp = 0;
          u8_temp += cmd_buff[4] * 10;
          u8_temp += cmd_buff[5];
          t.mon = u8_temp;
          
          /*
          day
          */
          u8_temp = 0;
          u8_temp += cmd_buff[6] * 10;
          u8_temp += cmd_buff[7];
          t.mday = u8_temp;
          
          /*
          hour
          */
          u8_temp = 0;
          u8_temp += cmd_buff[8] * 10;
          u8_temp += cmd_buff[9];
          t.hour = u8_temp;
          
          /*
          minute
          */
          u8_temp = 0;
          u8_temp += cmd_buff[10] * 10;
          u8_temp += cmd_buff[11];
          t.min = u8_temp;
          
          /*
          second
          */
          u8_temp = 0;
          u8_temp += cmd_buff[12] * 10;
          u8_temp += cmd_buff[13];
          t.sec = u8_temp;
          
          DS3231_set(t);
        }
      }
    }
}
