/****************************************************************
% Modul           : Informatikpraktikum 2                       *
%                                                               *
% Datum           : 29.03.2021                                  *
%                                                               *
% Funktion        : Beispielprogramm RealTime Clock             *
%                   !! Musterlösung !!                          *
% Implementation  : Arduino IDE                                 *
%                                                               *
% Author          : Hendrik Steffen, Sven Ponser                *
%                                                               *
% Anmerkungen     :                                             *
% Letzte Änderung : 29.03.2021                                  *
%                                                               *
%***************************************************************/
// Inkludieren der benötigten Bibliotheken

#include <Wire.h>
#include "DS3231.h"

DS3231 clock;
RTCDateTime dt;

void setup()
{
  Serial.begin(9600);

  Serial.println("Initialize DS3231");
  clock.begin();

  
  // Manuell einstellen (YYYY, MM, DD, HH, II, SS
  //clock.setDateTime(2020, 12, 22, 11, 37, 00);
  
  // Aktuelle Computerzeit an den Arduino senden
  clock.setDateTime(__DATE__, __TIME__);    
  
}

void loop()
{
  dt = clock.getDateTime();

  // Darstellung der Zeiten im Seriellen Monitor

  Serial.print(dt.year);   Serial.print(";");
  Serial.print(dt.month);  Serial.print(";");
  Serial.print(dt.day);    Serial.print(";");
  Serial.print(dt.hour);   Serial.print(";");
  Serial.print(dt.minute); Serial.print(";");
  Serial.print(dt.second); Serial.println(";");
  
  delay(1000);
}
