/*********************************************************************************************************
*
* File                : joysticks.ino
* Hardware Environment: UNO PLUS + Accessory Shield
* Build Environment   : Arduino
* Version             : V1.0.6
* By                  : WaveShare
*
*                                  (c) Copyright 2005-2014, WaveShare
*                                       http://www.waveshare.com
*                                       http://www.waveshare.net   
*                                          All Rights Reserved
*
*********************************************************************************************************/
/*
I/O define
*/
#define    KEY_UP        A1
#define    KEY_DOWN      A5
#define    KEY_LEFT      A3
#define    KEY_RIGHT     A2
#define    KEY_ENTER     A4

int key_release_flag = 1, i; 
int time_ticks = 0;

void setup(void)
{
  pinMode(13, OUTPUT);
  
  pinMode(KEY_UP, INPUT);
  digitalWrite(KEY_UP, HIGH);
  pinMode(KEY_DOWN, INPUT);
  digitalWrite(KEY_DOWN, HIGH);
  pinMode(KEY_LEFT, INPUT);
  digitalWrite(KEY_LEFT, HIGH);
  pinMode(KEY_RIGHT, INPUT);
  digitalWrite(KEY_RIGHT, HIGH);
  pinMode(KEY_ENTER, INPUT);
  digitalWrite(KEY_ENTER, HIGH);
 
  Serial.begin(9600);
}

void loop(void)
{
  /*
  led flash
  */
  delay(1);
  time_ticks++;  
  if(time_ticks == 500)
  {
    digitalWrite(13, HIGH);
  }
  else if(time_ticks == 1000)
  {
    digitalWrite(13, LOW);
    time_ticks = 0;
  }
  
  /*
  keyboard scan
  */
  if((digitalRead(KEY_UP) == LOW) || (digitalRead(KEY_DOWN) == LOW) || (digitalRead(KEY_LEFT) == LOW) || (digitalRead(KEY_RIGHT) == LOW) || (digitalRead(KEY_ENTER) == LOW))
  {
    if(key_release_flag)
    {
      delay(10);
      
      if((digitalRead(KEY_UP) == LOW) || (digitalRead(KEY_DOWN) == LOW) || (digitalRead(KEY_LEFT) == LOW) || (digitalRead(KEY_RIGHT) == LOW) || (digitalRead(KEY_ENTER) == LOW))
      {
        key_release_flag = 0;
        if(digitalRead(KEY_UP) == LOW)
          Serial.print("you press UP\n");
        else if(digitalRead(KEY_DOWN) == LOW)
          Serial.print("you press DOWN\n");
        else if(digitalRead(KEY_LEFT) == LOW)
          Serial.print("you press LEFT\n");
        else if(digitalRead(KEY_RIGHT) == LOW)
          Serial.print("you press RIGHT\n");
        else if(digitalRead(KEY_ENTER) == LOW)
          Serial.print("you press ENTER\n");
      }
    }
  }
  else
    key_release_flag = 1;
}
