/*********************************************************************************************************
*
* File                : rgb.ino
* Hardware Environment: UNO PLUS + Accessory Shield
* Build Environment   : Arduino 1.0.6
* Version             : V1.0
* By                  : WaveShare
*
*                                  (c) Copyright 2005-2014, WaveShare
*                                       http://www.waveshare.com
*                                       http://www.waveshare.net   
*                                          All Rights Reserved
*
*********************************************************************************************************/
#include <ChainableLED.h>
//Defines the num of LEDs used, The undefined 
//will be lost control.
#define NUM_LEDS  1

/*
I/O define
*/
const int rgb_pwr = 12;                                     //rgb power control
const int clk_pin = 6;                                      //clock
const int data_pin = 5;                                     //data
const int analog_pin = 0;                                   //pot input

/*
variable
*/
float hue = 0.0;
boolean up = true;
ChainableLED leds(clk_pin, data_pin, rgb_pwr, NUM_LEDS);    //defines the pin used on arduino.

void setup()
{
  leds.pwr_set(PWR_ENABLE);                                 //open the rgb power supply
}
void loop()
{
  delay(30);
  for (byte i=0; i<NUM_LEDS; i++)
    leds.setColorHSB(i, hue, 1.0, 0.5);
    
  if (up)
    hue+= 0.025;
  else
    hue-= 0.025;
    
  if (hue>=1.0 && up)
    up = false;
  else if (hue<=0.0 && !up)
    up = true;
}

