/*********************************************************************************************************
 *                   Hochschule Hamm-Lippstadt                              
 *********************************************************************************************************
 * Modul           : E31_Debug2MATLAB.ino                        
 *                                                               
 * Datum           : 26. Januar 2021                             
 *                                                               
 * Funktion        : Serielle Ausgabe der Temperatur zur Darstellung  in MATLAB    
 *                                             
 * Hardware        : UNO PLUS + Multisensor Shield                  
 * Implementation  : Arduino IDE 2.0.0-beta.4                    
 *                                                                                                                             
 * Author          : Prof. Schneider                             
 *                                                               
 * Bemerkung       : basierend auf Waveshare lm75.ino             
 *                   www.waveshare.com/wiki/AlphaBot             
 *                                                               
 * Letzte Änderung : 26. Januar 2021                             
 *                                                               
 ********************************************************************************************************/

/********************************************************************************************************/
/* Vorbereitung: Jumper E1 entfernen (A4->AL)                                                           */
/********************************************************************************************************/

/* Bibliotheken einbinden */
#include <inttypes.h>
#include <Wire.h>
#include <lm75.h>


TempI2C_LM75 termo = TempI2C_LM75(0x48,TempI2C_LM75::nine_bits); /* Temperatursensor LM75 adressieren */

void setup()
{
    Serial.begin(9600); /* Serielle Übertragung mit 9600 Bit/s starten */
}

void loop()
{
    Serial.println(termo.getTemp()); /* Zyklische Ausgabe der Temperatur in °C mit LF*/
}
