/*******************************************************************************************************
          Hochschule Hamm-Lippstadt
 *******************************************************************************************************
   Modul           : E32_Unterfunktion.ino

   Datum           : 16. November 2021

   Funktion        : Demo für den Aufruf einer Unterfunktion

   Hardware        : UNO PLUS + Multisensor Shield
   Implementation  : Arduino IDE 1.8.16


   Author          : Prof. Schneider

   Bemerkung       : Schauen Sie sich bitte auch die Verwendung der static-Variable an.

   Letzte Änderung : 16. November 2021

 ********************************************************************************************************/


void setup()
{ const unsigned int BAUDRATE_u16 = 9600; // Baudrate

  Serial.begin(BAUDRATE_u16);   // Serielle Übertragung mit 9600 Bit/s starten
  Serial.println("SETUP");
  Serial.println("starte LOOP");
} // End Setup
void loop()
{
  static int Schleifenzaehler_s16;
  const int Max_s16 = 5; // Maximaler Schleifenzähler
  int Cnt_s16 = 0;
  char String1_u8[] = "Zaehlerstand";
  char String2_u8[] = "Loop";
  
  for (Cnt_s16; Cnt_s16 < Max_s16; Cnt_s16++)
  {
    SerielleAusgabe(String1_u8,Cnt_s16);                  // Aufruf einer Unterfunktion
  }
  Schleifenzaehler_s16 = Addiere(Schleifenzaehler_s16,1); // Schleifenzähler inkrementieren
  SerielleAusgabe(String2_u8,Schleifenzaehler_s16);       // Aufruf einer Unterfunktion
  delay(1000);                                            // 1s Pause
} // End Loop

int Addiere(int x_s16, int y_s16)
{
  int Ergebnis_s16;             // Lokale Variable deklariert

  Ergebnis_s16 = x_s16 + y_s16; // Addition
  return Ergebnis_s16;          // Ergebnis Rückgabe
}

void SerielleAusgabe(char Text_u8[], int Wert_s16)
{
    Serial.print(Text_u8);      // Ausgabe
    Serial.print(": ");
    Serial.println(Wert_s16);
}
